using System;
using System.Text;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace CSSamples
{

  public class ChtRoute
  {
    public ChtRoute()
    {      
    }

    public String ID{ get; set; }
    public String RouteName { get; set; }
    public String LocName { get; set; }
    public String DrvName { get; set; } 

    public List<String> StopNames {get; set;} 
  }


  public partial class SetTheHoverPopupOfAMarker : System.Web.UI.Page
  {

   

    protected void Page_Load(object sender, EventArgs e)
    {
      if (!Page.IsPostBack)
      {
        ChtRoute objRoute = new ChtRoute
        {
          ID = "1001",
          RouteName = "RouteName",
          LocName = "LocName",
          DrvName = "DrvName"
        };


        ChtRoute objRoute2 = new ChtRoute
        {
          ID = "1002",
          RouteName = "RouteName2",
          LocName = "LocName2",
          DrvName = "DrvName2"
        };

        Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
        //Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
        //Map1.MapUnit = GeographyUnit.Meter;
        Map1.MapUnit = GeographyUnit.DecimalDegree;

        Map1.MapTools.OverlaySwitcher.Enabled = true;
        Map1.MapTools.OverlaySwitcher.BackgroundColor = GeoColor.StandardColors.DarkSlateGray;
        Map1.MapTools.OverlaySwitcher.BaseOverlayTitle = "Base Overlay";

        WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay("ThinkGeo");
       // worldMapKitOverlay.Projection = WorldMapKitProjection.SphericalMercator;
        Map1.CustomOverlays.Add(worldMapKitOverlay);


        GoogleOverlay googleHybrid = null;

        googleHybrid = new GoogleOverlay("Google");

        //String googleURI = "http://maps.google.com/maps?file=api&amp;v=2&amp;sensor=false&amp;key=ABQIAAAAL3V_tBQuIQVf2-4Gq1jjGRSVLVE14vdTwT2zogvhcfATEWPWuhSarNLvGnMVhRQHpskVcL_qqcFWuQ";
        String googleURI = "http://maps.google.com/maps/api/js?sensor=false";
        googleHybrid.JavaScriptLibraryUri = new Uri(googleURI);
        googleHybrid.GoogleMapType = GoogleMapType.Hybrid;
        Map1.CustomOverlays.Add(googleHybrid);
        //Map1.ActiveBaseOverlay = googleHybrid;
        Map1.ActiveBaseOverlay = worldMapKitOverlay;
        StringBuilder contentHtml = new StringBuilder();
        contentHtml.Append("<div style='padding:10px; font-size:10px; font-family:verdana;'><img alt='' align='left'")
            .Append("src='../../theme/default/samplepic/lawrencecity.jpg'/>&nbsp;&nbsp;Lawrence is a city in Northeastern Kansas")
            .Append("in the United States. Lawrence serves as the county seat of Douglas County, Kansas. Located 41 miles west ")
            .Append("of Kansas City, Lawrence is situated along the banks of the Kansas (Kaw) and Wakarusa Rivers. It is considered ")
            .Append("governmentally independent and is the principal city within the Lawrence, Kansas, Metropolitan Statistical Area, ")
            .Append("which encompasses all of Douglas County. As of the 2000 census, the city had a population of 80,098, making it ")
            .Append("the sixth largest city in Kansas. 2006 estimates[3] place the city's population at 89,110. A quintessential")
            .Append("college town, Lawrence is home to The University of Kansas and Haskell Indian Nations University.<br/>")
            .Append("&nbsp;&nbsp;<a href='http://en.wikipedia.org/wiki/Lawrence%2C_Kansas' ")
            .Append("target='_blank'><br/>more about Lawrence city...</a></div>");


        Proj4Projection proj4 = new Proj4Projection();
        proj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
        proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();


        RectangleShape rectShapeDecDeg = new RectangleShape(-180.0, 50.0, 70.0, 24.0); // US map
        //proj4.Open();
        //Map1.CurrentExtent = proj4.ConvertToExternalProjection(rectShapeDecDeg);
        Map1.CurrentExtent =rectShapeDecDeg;
        //map.RestrictedExtent = proj4.ConvertToExternalProjection(rectShape);
       // proj4.Close();      

        InMemoryMarkerOverlay markerOverlay = new InMemoryMarkerOverlay("MarkerOverlay");

        Dictionary<string, string> columnValues = new Dictionary<string, string>();

        for (int idx = 0; idx < 100; idx++)
        {
          columnValues.Add(idx.ToString(), "HelloThisisTest" + idx.ToString());
        }

        Feature featLawrence = new Feature(-95.28109, 38.95363);

        featLawrence.Tag = objRoute2;
        markerOverlay.Features.Add("Lawrence", featLawrence);



        Feature featLA = new Feature(-118.28109, 34.505363);
        featLA.Tag = objRoute;
        markerOverlay.Features.Add("LA", featLA);


        InMemoryMarkerOverlay markerOverlay1 = new InMemoryMarkerOverlay("MarkerOverlay1");

        PointShape pointSanDiego = new PointShape(-117.28109, 32.95363);

        pointSanDiego.Id = "San Diego";

        Feature featSanDiego = new Feature(pointSanDiego, columnValues);
        featSanDiego.Tag = objRoute;
        //markerOverlay1.Features.Add("San Diego", new Feature(-117.28109, 32.95363, "San Diego"));
        markerOverlay1.Features.Add(pointSanDiego.Id, featSanDiego);


        Feature featLA2 = new Feature(-118.88109, 34.405363, "LA2");
        featLA2.Tag = objRoute;
        markerOverlay1.Features.Add("LA2", featLA2);

        //markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = new WebImage(MapPath("~/theme/default/img/marker_green.gif"), 21, 25);
        markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = new WebImage("../../theme/default/img/marker_green.gif", 48, 48);
        markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.ContentHtml = contentHtml.ToString();
        markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.Width = 450;
        markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.Height = 290;
        markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.IsVisible = false;
        //markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.AutoPan = true;
        markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

       // markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level05;
        // markerOverlay.ZoomLevelSet.ZoomLevel06.Scale = 0;
       // markerOverlay.ZoomLevelSet.ZoomLevel06.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;



        markerOverlay1.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = new WebImage("../../theme/default/img/marker_blue.gif", 21, 25);
        markerOverlay1.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.ContentHtml = contentHtml.ToString();
        markerOverlay1.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.Width = 450;
        markerOverlay1.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.Height = 290;
        markerOverlay1.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.IsVisible = false;
      //  markerOverlay1.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.AutoPan = true;
        markerOverlay1.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

        Map1.CustomOverlays.Add(markerOverlay);
        Map1.CustomOverlays.Add(markerOverlay1);

        
        //markerOverlay.FeatureSource.Projection = proj4;
        //markerOverlay1.FeatureSource.Projection = proj4;

          
      }
      
    }

    protected void ModeSelection_Change(Object sender, EventArgs e)
    {

      InMemoryMarkerOverlay MarkerOverlay1 = (InMemoryMarkerOverlay)Map1.CustomOverlays["MarkerOverlay1"];

      InMemoryMarkerOverlay MarkerOverlay = (InMemoryMarkerOverlay)Map1.CustomOverlays["MarkerOverlay"];
      if (ModeSelectionList.Items[0].Selected)
      {
        MarkerOverlay.Features.Clear();

      }

      if (ModeSelectionList.Items[1].Selected)
      {
        MarkerOverlay1.Features.Clear();

      }
      return;
    }
  }
}
